=== src/economy/test/CMakeLists.txt ===
wl_test(test_economy
  SRCS
    economy_test_main.cc
    test_road.cc
    test_routing.cc
  DEPENDS
    base_macros
    base_test
    economy
    io_filesystem
    logic
    logic_map_objects
    logic_widelands_geometry
)
