=== src/ui_fsmenu/addons/CMakeLists.txt ===
wl_library(ui_addons
  SRCS
    contact.cc
    contact.h
    login_box.cc
    login_box.h
    manager.cc
    manager.h
    packager.cc
    packager.h
    packager_box.cc
    packager_box.h
    progress.cc
    progress.h
    remote_interaction.cc
    remote_interaction.h
    rows_ui.cc
    rows_ui.h
    screenshot_upload.cc
    screenshot_upload.h
  DEPENDS
    base_crypto
    base_time_string
    scripting_lua_table
    logic_filesystem_constants
    logic_tribe_basic_info
    io_filesystem
    graphic_text_layout
    ui_basic
    base
    io_filesystem_illegal_filename_check
    ui_fsmenu
    widelands_ball_of_mud
    io_profile
    base_exceptions
    logic
    widelands_options
    graphic_fonthandler
    logic_addons
    network
    graphic
    wui_common_mapdetails
)
